#include "m33.h"

V3& M33::operator[](int i) {

	return rows[i];

}

ostream& operator<<(ostream& ostr, M33 m) {

	return ostr << m[0] << m[1] << m[2];
}

V3 M33::operator*(V3 v) {

	M33 &m = *this;
	return V3(m[0] * v, m[1] * v, m[2] * v);

}

M33 M33::operator*(M33 m1) {

	M33 &m0 = *this;
	M33 ret;
	ret.SetColumn(0, m0*m1.GetColumn(0));
	ret.SetColumn(1, m0*m1.GetColumn(1));
	ret.SetColumn(2, m0*m1.GetColumn(2));
	return ret;

}

V3 M33::GetColumn(int i) {

	M33 &m = *this;
	return V3(m[0][i], m[1][i], m[2][i]);

}

void M33::SetColumn(int i, V3 c) {

	M33 &m = *this;
	m[0][i] = c[0];
	m[1][i] = c[1];
	m[2][i] = c[2];

}